/**
 * This class provides an iterator for the neighborhood of a point
 * in the simulation.
 * Each DirectionIter has two fields which are combined to form 
 * the next Direction object returned
 *
 * @author Matthew Arnold
 */
public class DirectionIter
{
  int curx = -1;
  int cury = -1;

    /**
     *  Constructor
     */
  DirectionIter()
    {}
  
    /**
     *  creates next Direction to return and generates
     *  the components of the next Direction; halts when has
     *  exhausted all directions.
     *
     *  @return new Direction object
     *
     */
  public Direction next()
    {
      if (curx > 1 || cury > 1)
	return null;

      Direction d = new Direction(curx,cury);
      curx++;
      if (curx==0 && cury == 0)
	curx++;
      else
	if (curx == 2) {
	  curx = -1;
	  cury++;
	}
      return d;
    }
}
