
import java.util.*;


/**
 * This provides a way to enumerate over a linked list.
 */
public class LinkedListEnumeration extends Object implements Enumeration
{
  private LinkedListNode current;

  /**
   * Creates a new LinkedListEnumeration 
   *
   * @param list  The LinkedList to enumerate over
   */
  public LinkedListEnumeration(LinkedList list)
    {
      current = list.getFirstNode();
    }

  /**
   * Tests if this enumeration contains more elements.   
   *
   * @return true if this enumeration contains more elements; false otherwise. 
   */
  public boolean hasMoreElements()
    {
      if(current == null)
	{
	  return(false);
	}
      else
	{
	  return(true);
	}
    }


  /**
   * Returns the next element of this enumeration.  It throws a
   * NoSuchElementException if no more elements exist. 
   *
   * @return the next element of this enumeration. 
   */
 public Object nextElement() throws NoSuchElementException
   {
     Object d;

     if(current == null)
       {
	 throw(new NoSuchElementException());
       }
     
     d = current.getData();
     current = current.getNext();
     
     return(d);
   }
	 


}
