
/**
 * This is a node in a linked list.  A node holds an Object, and a 
 * to another LinkedListNode.
 *
 * @author Rutgers-CS111
 */
public class LinkedListNode
{
  private Object data;
  private LinkedListNode next;

  /**
   * Create a new LinkedListNode to hold the diven object.  The
   * pointer to the next LinkedListNode is set to null.
   *
   * @param d    The Object to be stored in the LinkedListNode
   */
  public LinkedListNode(Object d)
  {
    data = d;
    next = null;
  }




  /**
   * Make this LinkedListNode next pointer point to the given node.
   *
   * @param n    The LinkedListNode to make next in the LinkedList
   */
  protected void setNext(LinkedListNode n)
  {
    next = n;
  }

  
  /**
   * Get the Object stored in the LinkedListNode
   *
   * @return   The Object stored in this LinkedListNode
   */
  public Object getData()
  {
    return(data);
  }
  

  /**
   * Get the next node in the LinkedList, possibly null
   *
   * @return  The next node in the LinkedList
   */
  public LinkedListNode getNext()
  {
    return(next);
  }


  /**
   * Return the string representation of this LinkedListNode.  This 
   * method assumes that the Object stored in it has a method
   * ToString.
   *
   * @return   The string representation of this segment.
   */
  public String toString()
  {
    return(data.toString());
  }
}
