/**
 *  class that represents a location in the simulation
 */
public class Location
{

  private int x;
  private int y;
  
    /*
     * observer for x co-ordinate
     * @return value of x co-ordinate
     */
  public int getX() { return x; }
    /**
     *  observer for y co-ordinate
     *  @return value of y co-ordinate
     */
  public int getY() { return y; }
    /**
     *  mutator for x co-ordinate
     * @param ix is value for x co-ordinate
     */
  public void setX(int ix) { x = ix; }
    /**
     *  mutator for y co-ordinate
     * @param iy is value for y co-ordinate
     */
  public void setY(int iy) { y = iy; }

    /**
     * copy constructor for Location
     *  @param ix is x co-ordinate
     *  @param iy is y co-ordinate
     */
  public Location (int ix,int iy)
    {
      x = ix;
      y = iy;
    }
    /**
     * constructor of Location (0,0)
     */
  public Location()
    {  //changed from empty function
        x = 0;
	y = 0;
    }

    /**
     * method enables addition of a direction to a location
     * @param d is direction to be added (has x and y portions)
     * @return new Location obtained 
     */
  public Location plus(Direction d)
    {
      return new Location(x+d.getX(), y+d.getY());
    }
}

