/**
 * This class provides encapsulation for an object in the simulation 
 * and its location. The type of the object needs to be the root of the
 * simulation hierarchy.
 *
 * @author Matthew Arnold
 */
public class LocationObjectPair
{
  
  private Location location;
  private Animal xObject;
    /**
     *  Copy constructor
     *
     */
  public LocationObjectPair(Location loc, Animal obj)
    {
      location = loc;
      xObject = obj;
    }
    /**
     *  observer for location
     *  @return location element of pair
     */
  public Location getLocation() { return location; }

    /**
     *  observer for object; need to change return type 
     * @return object element of pair
     */
  public Animal getObject() { return xObject; }
}
