/**
 *  abstract class which defines laysEggs() for all long-lived sessile
 *  animals
 */
abstract public class LongLivedSessile extends Sessile 
    implements ReproducesbyEggs
{
    /**
     *  constructor calls setmaxAge() to initialize maxAge
     */
    LongLivedSessile() {setmaxAge(10);}
    /**
     *  abstract method forces all actual animal descendent classes
     *  of LongLivedSessile to define a method that returns a new animal of 
     *  their kind;  allows laysEggs() to be inherited by all these classes
     *  @return LongLivedSessile reference to a new object of 
     *  a descendent class
     */
    abstract LongLivedSessile getNewLongLivedSessile();
    /**
     *  method uses random number generator to select how many
     *  offspring of long-lived sessile animal survive; current settings are
     *  50% 0 survivors, 50% 1 survivor;
     *  @return Set of long-lived sessile animals of one descendent class;
     *  an empty Set indicates no survivors
     */    
    public Set laysEggs()
    {
	 Set s = new Set();
	 double num = Math.random();
	 if (num <.5) {LongLivedSessile lls = getNewLongLivedSessile();
	               s.addTo(lls);
	 }
	 return s;
    }
}
