/**
 *  abstract class which stores a speed field for all moving animals,
 *  defines mutator and observer for speed field,
 *  defines getDirection() method for us in calculating makeMove()
 *  in descendent classes including FastMover and Seahorse;
 *  field int speed - stores speed of movement of an animal
 */

public abstract class MovingAnimal extends Animal
{
	private int speed;
    /**
     *  mutator for speed field; only accessible to descendent classes
     *  @param int s - used to set speed
     */
	protected void setSpeed(int s) {speed = s;}
    /**
     *  observer for speed field; accessible to clients
     */
	public int getSpeed(){return speed;}
    /**
     *  method provided to pick next direction to try to move
     *  each direction equally likely;
     *  only available to descendent classes
     */
        protected Direction getDirection()
	{
	  double z = Math.random();
	  int dirx, diry;
	  
	  if  (z < .33) dirx = -1;
          else if (z < .67) dirx = 0;
	  else dirx = +1;
	  z = Math.random();
	  if  (z < .33) diry = -1;
          else if (z < .67) diry = 0;
	  else diry = +1;
	  return (new Direction(dirx,diry));
	}
}

