/**
 * This class provides ability to print H for Seahorse objects,
 * defines makeMove() and laysEggs() for Seahorses
 *
 * @author Barbara Ryder
 */
public class Seahorse extends MovingAnimal implements ReproducesbyEggs
{
    /**
     *  constructor sets speed field and maxAge field
     */
	Seahorse(){ setSpeed(2); setmaxAge(5); }
    /**
     *
     *  provides print character for Seahorse object
     *  @return char 'H' for Seahorse
    */
	public char getPrintChar(){return 'H';}
    /**
     *  function provides a new Location to which the Seahorse object
     *  can move; checks that it moves with the current
     *  note: chose to try 8 randomly chosen directions
     *  @return Location to which Seahorse can move
     */
        public Location makeMove(Location myLoc, World myWorld)
	{ 
	  // can't hoist this code upwards into MovingAnimal 
	  // without exposing details of its subclasses; not a good idea
	    Location there;
	  // may try same direction more than once
	    for (int t = 8; t>0; t--)
            { Direction d = getDirection();
             //try another direction
	     if (!d.isWithCurrent(myLoc, myWorld)) continue;
	     else{
	   // try to move from current location to a location speed 
	   // steps away in direction d; check if that site is already occupied
	   //
             there = myLoc.plus(d.incrDirn(getSpeed()));
           // need to try another direction
	     if (myWorld.whatIs(there) != null) continue; 
	     else return there;
	     }
	   }
	    return null;//animal can't move this time step
        }
    /**
     *  method for reproducing by laying eggs; always lays 1 egg
     *  per reproduction period
     *  @return Set with one new Seahorse object
     */
      public Set laysEggs()
    { 
	 Set s = new Set();
         s.addTo(new Seahorse());
	 return s;
    }
}


