import java.util.*;

/**
 * This provides a way to enumerate over a set.
 */
public class SetEnumeration extends Object implements Enumeration
{
  private LinkedListEnumeration lle;

  /**
   * Creates a new SetEnumeration 
   *
   * @param list  The Set to enumerate over
   */
  public SetEnumeration(Set s)
    {
      lle = new LinkedListEnumeration(s.getList());
    }



  /**
   * Tests if this enumeration contains more elements.   
   *
   * @return true if this enumeration contains more elements; false otherwise. 
   */
  public boolean hasMoreElements()
    {
      return(lle.hasMoreElements());
    }


  /**
   * Returns the next element of this enumeration.  It throws a
   * NoSuchElementException if no more elements exist. 
   *
   * @return the next element of this enumeration. 
   */
 public Object nextElement() throws NoSuchElementException
   {
     return(lle.nextElement());
   }
	 


}
