/**
 *  abstract class which defines buds() for all short-lived sessile animals
 */
abstract public class ShortLivedSessile extends Sessile
    implements ReproducesbyBudding
{
    /**
     * constructor calls setmaxAge() to initialize ages for short-lived 
     * animals
     */
    ShortLivedSessile() {setmaxAge(6);}

    /**
     *  abstract method forces all actual animal descendent classes
     *  of ShortLivedSessile to define a method that returns a new animal of 
     *  their kind;  allows buds() to be inherited by all these classes
     *  @return ShortLivedSessile reference to a new object of 
     *  a descendent class
     */
    abstract public ShortLivedSessile getNewShortLivedSessile();

    /**
     *  method uses random number generator to select how many
     *  offspring of short-lived sessile animal survive; current settings are
     *  30% 0 survivors, 30% 1 survivor; 40% 2 survivors
     *  @return Set of short-lived sessile animals of one descendent class;
     *  an empty Set indicates no survivors
     */
    public Set buds()
    {   
	 Set s = new Set();
	 double num = Math.random();
	 if (num < .3) s.addTo(getNewShortLivedSessile());
         else if (num < .7) {
	     s.addTo(getNewShortLivedSessile());
             s.addTo(getNewShortLivedSessile());
	    }
	 return s;
    }
}
