import java.util.Vector;
/**
 * This class provides an iterator for the simulation (World)
 *
 * @author Matthew Arnold
 */
public class WorldEnumeration {

  private Vector pairVector = new Vector();

    /**
     *  constructor - takes World object and build vector of
     *  LocationObjectPairs
     */
  WorldEnumeration(World world) {
    
    for(int r=0; r<world.getWorldSize(); r++)
      for(int c=0; c<world.getWorldSize(); c++) {

	Location loc = new Location(r,c);
	LocationObjectPair pair = world.getWorldGrid().getGridElement(loc);
	if (pair != null) 
	  {
	    pairVector.addElement(pair);
	 }
      }
  }

    /**
     *  checks if there are more LocationObjectPairs to return
     *
     *  @return true if these is another LocationObjectPair, otherwise false
     */
  public boolean hasMoreElements()
    {
      if(pairVector.isEmpty())
	return false;
      else
	return true;
    }

    /**
     *  returns either next LocationObjectPair from iterator or null
     *
     *  @return next LocationObjectPair from iterator
     */
  public LocationObjectPair nextElement() 
    { 
      LocationObjectPair pair;
      
      if (pairVector.isEmpty())
	return null;
      
      int spot = pairVector.size() - 1;
      
      pair = (LocationObjectPair)pairVector.elementAt(spot);
      pairVector.removeElementAt(spot);

      return pair;
    }

} 












